"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var fs = require("fs");
var graphql_codegen_core_1 = require("graphql-codegen-core");
exports.introspectionFromExport = function (file) {
    console.log("Loading GraphQL Introspection from JavaScript ES6 export: " + file + "...");
    return new Promise(function (resolve, reject) {
        if (fs.existsSync(file)) {
            try {
                var schema = require(file);
                if (schema && schema instanceof graphql_codegen_core_1.GraphQLSchema) {
                    var result = graphql_codegen_core_1.graphql(schema, graphql_codegen_core_1.introspectionQuery).then(function (res) { return res.data; });
                    resolve(result);
                }
                else {
                    reject(new Error("Invalid export from export file " + file + ", make sure to default export your GraphQLSchema object!"));
                }
            }
            catch (e) {
                reject(e);
            }
        }
        else {
            reject("Unable to locate introspection from export file: " + file);
        }
    });
};
//# sourceMappingURL=introspection-from-export.js.map